/*----- PROTECTED REGION ID(Agilent532x0AClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        Agilent532x0AClass.h
//
// description : Include for the Agilent532x0A root class.
//               This class is the singleton class for
//                the Agilent532x0A device class.
//               It contains all properties and methods which the 
//               Agilent532x0A requires only once e.g. the commands.
//
// project :     Agilent Frequency counter(timer)
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Agilent532x0AClass_H
#define Agilent532x0AClass_H

#include <tango.h>
#include <Agilent532x0A.h>


/*----- PROTECTED REGION END -----*/	//	Agilent532x0AClass.h


namespace Agilent532x0A_ns
{
/*----- PROTECTED REGION ID(Agilent532x0AClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	Agilent532x0AClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute frequency class definition
class frequencyAttrib: public Tango::Attr
{
public:
	frequencyAttrib():Attr("frequency",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~frequencyAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent532x0A *>(dev))->read_frequency(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent532x0A *>(dev))->is_frequency_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command ClearErrors class definition
class ClearErrorsClass : public Tango::Command
{
public:
	ClearErrorsClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ClearErrorsClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ClearErrorsClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Agilent532x0A *>(dev))->is_ClearErrors_allowed(any);}
};


/**
 *	The Agilent532x0AClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  Agilent532x0AClass : public Tango::DeviceClass
#else
class Agilent532x0AClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(Agilent532x0AClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Agilent532x0AClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static Agilent532x0AClass *init(const char *);
		static Agilent532x0AClass *instance();
		~Agilent532x0AClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		Agilent532x0AClass(string &);
		static Agilent532x0AClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	Agilent532x0A_H
